'* ------------------------------------------------------- *
'*                    TBUTIL.INC                           *
'*          (c) 1989 Jrg Braun & TOOLBOX                  *
'* ------------------------------------------------------- *

'* DEFINITION

REM FN LowCase$(urspr$)
REM Umwandlung von Grobuchstaben (CHAR) in
REM Kleinbuchstaben. Im Gegensatz zu LCASE$
REM auch fr nationale Sonderzeichen.
REM Aufruf z.B.: A$ = INKEY$: A$ = FNLowCase$(A$)

REM DEF FN UpCase$(urspr$)
REM Umwandlung von Kleinbuchstaben (CHAR) in
REM Grobuchstaben. Im Gegensatz zu UCASE$ auch
REM fr nationale Sonderszeichen.
REM Aufruf z.B.: A$ = INKEY$: A$ = FNUpCase$(A$)

REM DEF FN LowString$(InString$)
REM Umwandlung von Strings in Groschreibung.
REM Aufruf z.B.: PRINT FNUpString$("ein test: .")

REM DEF FN LowString$(InString$)
REM Umwandlung von Strings in Kleinschreibung.
REM Aufruf z.B.: PRINT FN LowString$("EIN TEST: .")

REM SUB Copy(infile$,outfile$)
REM Inhalt einer beliebigen Datei wird in eine neue Datei
REM 16 kB-weise binr bertragen. Die neue Datei erhlt
REM das aktuelle Datum und nicht das Erstellungsdatum der
REM Originaldatei. Andere Dateien (#1 - #4) knnen gleich-
REM zeitig geffnet bleiben.
REM Zeigervariable mu LONG INTEGER sein.

'* IMPLEMENTATION

DEF FN LowCase$(urspr$)
  IF LEN(urspr$) = 1 THEN
    SELECT CASE ASC(urspr$)
      CASE 65 TO 90
        FN LowCase$ = LCASE$(urspr$)
      CASE ELSE
        SELECT CASE urspr$
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
          CASE "":  FN LowCase$ = ""
                                     ' nach Bedarf erweitern
          CASE ELSE: FN LowCase$ = urspr$
        END SELECT
    END SELECT
  END IF
END DEF


DEF FN UpCase$(urspr$)
  IF LEN (urspr$) = 1 THEN
    SELECT CASE ASC(urspr$)
      CASE 97 TO 122
        FN UpCase$ = UCASE$(urspr$)
      CASE ELSE
        SELECT CASE urspr$
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "":            FN UpCase$ = ""
          CASE "","":        FN Upcase$ = "E"
          CASE "","","":    FN Upcase$ = "A"
          CASE "","","":    FN Upcase$ = "U"
          CASE "","","","":FN Upcase$ = "I"
          CASE "","","":    FN Upcase$ = "O"
          CASE "":            FN Upcase$ = "SS"
                                     ' nach Bedarf erweitern
          CASE ELSE:           FN UpCase$ = urspr$
        END SELECT
    END SELECT
  END IF
END DEF


DEF FN UpString$(InString$)
LOCAL i&, txt$

  txt$ = ""
  FOR i& = 1 TO LEN(InString$)
      txt$ = txt$ + FN UpCase$(MID$(Instring$, i&, 1))
  NEXT i&
  FN Upstring$ = txt$
END DEF


DEF FN LowString$(InString$)
LOCAL i&, txt$

  txt$ = ""
  FOR i& = 1 TO LEN(InString$)
    txt$ = txt$ + FN LowCase$(MID$(InString$, i&, 1))
  NEXT i&
  FN LowString$ = txt$
END DEF

SUB Copy(infile$, outfile$)
LOCAL i&, datstring$

  OPEN infile$  FOR BINARY AS #5
  OPEN outfile$ FOR BINARY AS #6
    i& = 0
    WHILE NOT EOF (5)
      datstring$ = ""
      SEEK 5, i&
      GET$ #5, 16384, datstring$
      SEEK 6, i&
      PUT$ #6, datstring$
      INCR i&, 16384
    WEND
  CLOSE #5
  CLOSE #6
END SUB

'* ------------------------------------------------------- *
'*                 Ende von TBUTIL.INC                     *
